> ## Documentation Index
> Fetch the complete documentation index at: https://docsnewgen.flexxible.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Create a tenant

> Create a new tenant and an associated organization for the specified owner organization. The request body uses a `type` discriminator with exclusive routes: `tenant` (END CUSTOMER) and `organization` (PARTNER/WHOLESALER).



## OpenAPI

````yaml /en/api-reference/openapi.en-v2.json post /v2/organizations/{organization_id}/tenants
openapi: 3.0.3
info:
  title: API Publica Portal
  version: 2.0.0
  description: Public REST API for portal
servers:
  - url: https://api.flexxible.net
    description: Portal API (production)
security:
  - bearerAuth: []
tags:
  - name: Digital activity
    description: Creation of core process groups by organization
  - name: Roles
    description: Endpoint de creacion de roles de organizacion
  - name: Usuarios
    description: Endpoint de creacion de usuarios de organizacion
  - name: Grupos de workspaces
    description: Endpoints de gestión de grupos de workspaces
  - name: Workspaces
    description: Endpoint de eliminacion de workspaces de la organizacion
  - name: Aplicaciones instaladas
    description: Endpoint de detalle de aplicación instalada de la organización
  - name: Autenticación
    description: Endpoints de autenticación y contexto de sesión
  - name: Microservicios
    description: Detalle de microservicios por organizacion
  - name: Operaciones
    description: Consulta de detalle de operaciones por organización
  - name: Organización
    description: Operaciones de organización
  - name: Objetivos de política de parches
    description: Endpoints de gestión de objetivos de política de parches
  - name: Configuraciones de producto
    description: Endpoints de gestión de configuraciones de producto
  - name: Grupos de reporte
    description: Operaciones sobre grupos de reporte
  - name: Sesiones
    description: Endpoint de detalle de sesion de la organizacion
  - name: Tenants
    description: Endpoints de gestión de tenants
paths:
  /v2/organizations/{organization_id}/tenants:
    post:
      tags:
        - Tenants
      summary: Create a tenant
      description: >-
        Create a new tenant and an associated organization for the specified
        owner organization. The request body uses a `type` discriminator with
        exclusive routes: `tenant` (END CUSTOMER) and `organization`
        (PARTNER/WHOLESALER).
      operationId: createTenant
      parameters:
        - name: organization_id
          in: path
          required: true
          schema:
            type: string
            maxLength: 24
            pattern: ^[0-9a-f]{24}$
          description: >-
            The unique identifier of the owning organization that will create
            the tenant
          example: 507f1f77bcf86cd799439011
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/CreateTenantRequestV2'
            examples:
              create-tenant-end-customer:
                summary: Create tenant for END CUSTOMER organization
                value:
                  type: tenant
                  name: Tenant de producción
                  tenant_config:
                    product_config_id: 507f1f77bcf86cd799439030
                    analyzer: existing
                  policy_id: 507f1f77bcf86cd799439050
                  organization_email: tenant@example.com
                  organization_language: en
                  organization_country: US
                  organization_industry: Tecnología
              create-tenant-partner-or-wholesaler:
                summary: Create tenant for PARTNER or WHOLESALER organization
                value:
                  type: organization
                  name: Tenant empresarial
                  organization_config:
                    product_id: 507f1f77bcf86cd799439030
                    region: west-eu-01_one
                  policy_id: 507f1f77bcf86cd799439050
                  organization_email: enterprise@example.com
                  organization_language: es
                  organization_country: ES
                  organization_industry: Finanzas
      responses:
        '201':
          description: >-
            Tenant and associated organization successfully created. Returns the
            created tenant resource.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/TenantByIdV2'
        '400':
          $ref: '#/components/responses/BadRequest'
          description: >-
            Bad Request. Common causes: - Invalid request body or path
            parameters - Mixed exclusive configurations (`tenant_config` and
            `organization_config`) - Missing mandatory fields for selected type
            - Invalid ID format
        '401':
          $ref: '#/components/responses/Unauthorized'
          description: Unauthorized - authentication required
        '404':
          $ref: '#/components/responses/NotFound'
          description: Owner organization not found
        '422':
          description: >-
            Unprocessable entity - Business logic validation error. Common
            causes: - Product config not found - Organization not eligible to
            create tenants - Organization does not exist in build - Organization
            has no eligible products - Invalid partner relationship -
            Organization and parent organization are end customers - Referenced
            entity not found
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
        '429':
          $ref: '#/components/responses/TooManyRequests'
        '500':
          $ref: '#/components/responses/InternalServerError'
components:
  schemas:
    CreateTenantRequestV2:
      type: object
      additionalProperties: false
      properties:
        type:
          type: string
          enum:
            - tenant
            - organization
          description: >-
            Creation type. `tenant` for END CUSTOMER, `organization` for
            PARTNER/WHOLESALER.
        name:
          type: string
          maxLength: 512
        tenant_config:
          type: object
          additionalProperties: false
          nullable: true
          description: Specific configuration for `type=tenant`.
          properties:
            product_config_id:
              type: string
              maxLength: 24
              pattern: ^[0-9a-f]{24}$
            analyzer:
              type: string
              enum:
                - existing
                - new
          required:
            - product_config_id
            - analyzer
        organization_config:
          type: object
          additionalProperties: false
          nullable: true
          description: Specific configuration for `type=organization`.
          properties:
            product_id:
              type: string
              maxLength: 24
              pattern: ^[0-9a-f]{24}$
            region:
              type: string
              maxLength: 128
          required:
            - product_id
            - region
        policy_id:
          type: string
          maxLength: 24
          pattern: ^[0-9a-f]{24}$
        organization_email:
          type: string
          maxLength: 512
        organization_language:
          type: string
          maxLength: 512
        organization_country:
          type: string
          maxLength: 512
        organization_industry:
          type: string
          maxLength: 512
      required:
        - type
        - name
        - organization_email
        - organization_language
        - organization_country
        - organization_industry
      description: >-
        Unique creation body with conditional fields by `type`: if
        `type=tenant`, requires `tenant_config`; if `type=organization`,
        requires `organization_config`.
    TenantByIdV2:
      type: object
      required:
        - id
        - organization_id
        - created_at
        - name
        - region
      properties:
        id:
          type: string
        organization_id:
          type: string
          description: Tenant organization ID
        created_at:
          type: string
          format: date-time
        name:
          type: string
        region:
          type: string
        product_id:
          type: string
          nullable: true
          description: Product ID
        policy_id:
          type: string
          nullable: true
          description: Policy ID
    ErrorResponse:
      type: object
      properties:
        error:
          type: object
          properties:
            message:
              type: string
            code:
              type: string
            details:
              type: string
          required:
            - message
            - code
      required:
        - error
  responses:
    BadRequest:
      description: Bad Request
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ErrorResponse'
    Unauthorized:
      description: Unauthorized
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ErrorResponse'
    NotFound:
      description: Not Found
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ErrorResponse'
    TooManyRequests:
      description: Too Many Requests
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ErrorResponse'
    InternalServerError:
      description: Internal Server Error
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ErrorResponse'
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer
      bearerFormat: JWT

````